#!/usr/bin/env python

import sys
import time
import linuxcnc
import hal


h = hal.component("active-gcodes")
h.newpin("radius-mode", hal.HAL_BIT, hal.HAL_OUT)
h.newpin("imperial-mode", hal.HAL_BIT, hal.HAL_OUT)
h.newpin("feed-rate", hal.HAL_FLOAT, hal.HAL_OUT)

debug = 0

try:
    h.ready()
    while 1:
        s = linuxcnc.stat() # create a connection to the status channel
        s.poll() # get current values, e.g. (0, 800, -1, 180, 400, 200, 900, 940, 540, 490, 990, 640, -1, 970, 911, 80)
        
        #h["move-mode"] = s.gcodes[0]
        #h["canned-cycle-mode"] = s.gcodes[1]
        #h["plane-mode"] = s.gcodes[3]
        #h["cutter-compensation-mode"] = s.gcodes[4]
        h["imperial-mode"] = ( True if 200 in s.gcodes else False )
        #h["distance-mode"] = s.gcodes[6]
        #h["feed-rate-mode"] = s.gcodes[7]
        #h["coordinate-system"] = s.gcodes[8]
        #h["tool-length-compensation"] = ( True if s.gcodes[9] != 490 else False )
        #h["canned-cycle-return-level"] = s.gcodes[10]
        #h["path-blending"] = s.gcodes[11]
        #h["spindle-control-mode"] = ( "CSS" if s.gcodes[13] == 960 else "RPM" )
        #h["arc-distance-mode"] = s.gcodes[14]
        h["radius-mode"] = ( True if 80 in s.gcodes else False )
        h["feed-rate"] = (s.settings[1])
        #print s.gcodes
        
        time.sleep(1)
        
except linuxcnc.error, detail:
    print "error", detail
    sys.exit(1)

